/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class ChinaMine extends Applet implements MouseListener, Runnable
{
	private boolean  iconState=true;
	private Image akey;
	public static void exit()
	{
		Config.saveConfig();
		if(!Constant.isApplet)
//if it is an application, the progam will save the recodes when exit
		{
			System.exit(0);
		}
	}

	public static void main(String[] args)
	{
		int i=0;
//when you run this game as an application, the program start from here
		Constant.isApplet=false;
		Constant.topApplet=new ChinaMine();

		try
		{
//get images for use
			Toolkit aKit=Toolkit.getDefaultToolkit();
			MediaTracker aTracker=new MediaTracker(Constant.topApplet);
			Image icon,block, face, led, akey;

			Constant.akeyIcon=akey=aKit.getImage("akey.gif");
			aTracker.addImage(akey,0);
			try
			{
				aTracker.waitForAll();
			}
			catch(InterruptedException e){};

			Constant.initLevelConst();
			Config.loadConfig();
			Constant.resetName();
			Constant.onlyFrame=new MainFrame();
		}
		catch(AWTError e){}
	}

	public int loadStage=0;
	boolean loaded=false;
	public void init()
	{
//when you start the game as an applet, it begin from here
		Constant.isApplet=true;
		Constant.topApplet=this;
		resize(Constant.iconButtonW,Constant.iconButtonH);
		setBackground(Color.lightGray);
		Thread tempThread=new Thread(this);
		tempThread.start();
	}

	public void run()
	{
		repaint();
		addMouseListener(this);
		MediaTracker aTracker=new MediaTracker(this);

//get images for use
		loadStage++;
		repaint();
		Constant.akeyIcon=akey=getImage(getCodeBase(),"akey.gif");
		aTracker.addImage(akey,0);

		try
		{
			aTracker.waitForAll();
		}
		catch(InterruptedException e){}
		loadStage++;
		repaint();
		Constant.initLevelConst();
		Config.loadConfig();
		loadStage++;
		repaint();
		Constant.styles[Config.style].getStyle();
		loadStage++;
		repaint();
		Constant.resetName();
		try
		{
			Class.forName("MainFrame");
			loadStage++;
			repaint();
			Class.forName("HitCounter");
			loadStage++;
			repaint();
			Class.forName("Register");
			loadStage++;
			repaint();
			Class.forName("AboutChinaMine");
			loadStage++;
			repaint();
			Class.forName("ShowImage");
			loadStage++;
			repaint();
			Class.forName("ShowBestTime");
			loadStage++;
			repaint();
			Class.forName("ShowString");
		}
		catch(ClassNotFoundException e){}
		loaded=true;
System.out.println("Load counts: "+loadStage);
		repaint();
	}

	public void update(Graphics g)
	{
		paint(g);
	}

	public void paint(Graphics g)
	{
		if(Constant.isApplet)
		{
			if(loaded)
			{
				g.drawImage(iconState?Constant.styles[Config.style].iconup:Constant.styles[Config.style].icondown,0,0,this);
				return;
			}
		}
		g.setColor(Color.blue);
		g.fillRect(1,1,1,2);	g.fillRect(2,3,1,3);	g.fillRect(3,4,1,1);	g.fillRect(4,3,1,1);
		g.fillRect(5,4,1,1);	g.fillRect(6,3,1,3);	g.fillRect(7,1,1,2);	g.fillRect(9,3,1,2);
		g.fillRect(10,2,2,1);	g.fillRect(10,5,2,1);	g.fillRect(12,3,1,2);	g.fillRect(13,5,1,1);
		g.fillRect(15,1,1,1);	g.fillRect(15,3,1,3);	g.fillRect(17,2,3,1);	g.fillRect(18,1,1,5);
		g.fillRect(19,5,1,1);	g.fillRect(2,8,1,6);	g.fillRect(3,13,2,1);	g.fillRect(6,11,1,2);
		g.fillRect(9,11,1,2);	g.fillRect(7,10,2,1);	g.fillRect(7,13,2,1);	g.fillRect(11,11,1,2);
		g.fillRect(14,11,1,2);	g.fillRect(12,10,2,1);	g.fillRect(12,13,2,1);	g.fillRect(15,13,1,1);
		g.fillRect(17,11,1,2);	g.fillRect(18,13,2,1);	g.fillRect(18,10,2,1);	g.fillRect(20,8,1,5);
		g.fillRect(21,13,1,1);	g.fillRect(23,9,1,1);	g.fillRect(23,11,1,3);	g.fillRect(25,11,1,3);
		g.fillRect(28,11,1,3);	g.fillRect(25,10,3,1);	g.fillRect(30,11,1,2);	g.fillRect(31,10,2,1);
		g.fillRect(31,13,2,1);	g.fillRect(31,16,2,1);	g.fillRect(30,15,1,1);	g.fillRect(33,11,1,5);
		g.setColor(Color.green);
		int i;
		for(i=0;i<loadStage;i++)
			g.fillRect(2+3*(i%11), 20+4*(i/11), 2, 2);
		g.setColor(Color.gray);
		for(;i<13;i++)
			g.fillRect(2+3*(i%11), 20+4*(i/11), 2, 2);
		g.setColor(Color.red);
		g.fillRect(2+3*(i%11), 20+4*(i/11), 2, 2);
	}

	public void mousePressed(MouseEvent evt)
	{
		if( loaded && !MainFrame.isAlive() )
		{
			iconState=false;
			repaint();
		}
	}

	boolean firstInvoke=true;
	public void mouseReleased(MouseEvent evt)
	{
		int x=evt.getX(), y=evt.getY();
		if( loaded && !MainFrame.isAlive() )
		{
			iconState=true;
			repaint();
			if(x>=0 && y>=0 && x<Constant.iconW && y<Constant.iconH)
			{
				Constant.onlyFrame=new MainFrame();
				if(firstInvoke)
				{
					registPlay();
					firstInvoke=false;
				}
			}
		}
	}
	public void mouseEntered(MouseEvent evt)
	{}
	public void mouseExited(MouseEvent evt)
	{}
	public void mouseClicked(MouseEvent evt)
	{}

	public String getAppletInfo()
	{
		return Constant.languages[0].copyright;
	}

	public String[][] getParameterInfo()
	{
		return Constant.parameterInfo;
	}

	void registPlay()
	{
		Thread counterThread=new Thread(new HitCounter());
		counterThread.start();
	}
}
