import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class CombatDialog extends Dialog implements WindowListener,
		ActionListener, ItemListener, TextListener, Runnable
{
	Checkbox server, client, tag;
	TextField serverName;
	Button connect, agree, cancel;
	Choice ch1, ch2, ch3;
	Label lbl1, lbl2, lbl3;
	Panel pl1, pl2, pl3;
	boolean mode=false; // false is client, true is server
	byte[] magicString={15,34,123,43,1};
	byte[] antiMagic={15,34,122,43,1};
	boolean connected=false;

	static byte AGREE=1, OVER=2, SET=3, CH1=1, CH2=2, CH3=3, TAG=4;
	public CombatDialog()
	{
		super(Constant.onlyFrame, "Select your combat option here", false);
		int y=0;
		setLocation(200,200);
		GridBagConstraints gbc=new GridBagConstraints();
		GridBagLayout layout=new GridBagLayout();
		CheckboxGroup cbgroup=new CheckboxGroup();

		setLayout(layout);
		gbc.insets=new Insets(5, 5, 5, 5);
		server=new Checkbox("Server Mode", false, cbgroup);
		gbc.gridx=0;
		gbc.gridy=y;
		layout.setConstraints(server, gbc);

		client=new Checkbox("Client Mode", true, cbgroup);
		gbc.gridx=1;
		gbc.gridy=y;
		layout.setConstraints(client, gbc);

		y++;
		serverName=new TextField(20);
		gbc.gridx=0;
		gbc.gridy=y;
		layout.setConstraints(serverName, gbc);

		connect=new Button("Connect");
		gbc.gridx=1;
		gbc.gridy=y;
		layout.setConstraints(connect, gbc);

		y++;
		pl1=new Panel();
		lbl1=new Label("Explode palnaty: ");
		ch1=new Choice();
		ch1.add("None");
		ch1.add("Small");
		ch1.add("Medium");
		ch1.add("Large");
		ch1.select(2);
		pl1.add(lbl1);
		pl1.add(ch1);
		gbc.gridx=0;
		gbc.gridy=y;
		gbc.gridwidth=2;
		gbc.anchor=GridBagConstraints.WEST;
		layout.setConstraints(pl1, gbc);

		y++;
		pl2=new Panel();
		lbl2=new Label("Uncover palnaty to your enemy: ");
		ch2=new Choice();
		ch2.add("None");
		ch2.add("Small");
		ch2.add("Big");
		ch2.select(1);
		pl2.add(lbl2);
		pl2.add(ch2);
		gbc.gridx=0;
		gbc.gridy=y;
		layout.setConstraints(pl2, gbc);

		y++;
		pl3=new Panel();
		lbl3=new Label("Select your level: ");
		ch3=new Choice();
		ch3.add("Beginner");
		ch3.add("Intermediate");
		ch3.add("Expert");
		ch3.add("Master");
		ch3.select(Config.level);
		pl3.add(lbl3);
		pl3.add(ch3);
		gbc.gridx=0;
		gbc.gridy=y;
		layout.setConstraints(pl3, gbc);

		y++;
		tag=new Checkbox("Use tag");
		tag.setState(Config.canTag);
		gbc.gridx=0;
		gbc.gridy=y;
		gbc.anchor=GridBagConstraints.CENTER;
		layout.setConstraints(tag, gbc);

		y++;
		agree=new Button("Agree");
		gbc.gridx=0;
		gbc.gridy=y;
		gbc.gridwidth=1;
		layout.setConstraints(agree, gbc);

		cancel=new Button("Cancel");
		gbc.gridx=1;
		gbc.gridy=y;
		layout.setConstraints(cancel, gbc);

		add(server);
		add(client);
		add(serverName);
		add(connect);
		add(pl1);
		add(pl2);
		add(pl3);
		add(tag);
		add(agree);
		add(cancel);
		pack();
		setResizable(false);
		server.addItemListener(this);
		client.addItemListener(this);
		connect.addActionListener(this);
		ch1.addItemListener(this);
		ch2.addItemListener(this);
		ch3.addItemListener(this);
		tag.addItemListener(this);
		agree.addActionListener(this);
		cancel.addActionListener(this);
		serverName.addTextListener(this);
		addWindowListener(this);
		lbl1.setEnabled(false);
		lbl2.setEnabled(false);
		lbl3.setEnabled(false);
		ch1.setEnabled(false);
		ch2.setEnabled(false);
		ch3.setEnabled(false);
		tag.setEnabled(false);
		agree.setEnabled(false);
		connect.setEnabled(false);
		cancel.setEnabled(false);
		show();
		(new Thread(this)).start();
	}

	public void run()
	{
		if(connected==false)
		{
			ServerSocket ss=null;
			Socket s=null;
			try
			{
				ss=new ServerSocket(9527);
			}
			catch(IOException e)
			{
				new ErrorDialog("Can not open socket server, you must run in client mode.");
				client.setState(true);
				server.setEnabled(false);
				serverName.setEditable(true);
				String tempString=serverName.getText();
				if(tempString==null || tempString.equals(""))
					connect.setEnabled(false);
				else
					connect.setEnabled(true);
				return;
			}
			while(true)
			{
				try
				{
					s=null;
					s=ss.accept();
					InputStream input;
					OutputStream output;
					input=s.getInputStream();
					output=s.getOutputStream();
					if(!mode)
					{
						output.write(antiMagic);
						s.close();
						continue;
					}
					// now in server mode
					output.write(magicString);
					byte[] tempBytes=new byte[5];
					input.read(tempBytes);
					for(int i=0;i<5;i++)
					{
						if(tempBytes[i]!=magicString[i])
							throw(new IOException());
					}
					server.setEnabled(false);
					client.setEnabled(false);
					serverName.setText("Connected from "+s.getInetAddress());
					Constant.input=s.getInputStream();
					Constant.output=s.getOutputStream();
					Constant.output.write(SET);	Constant.output.write(CH1);	Constant.output.write(ch1.getSelectedIndex());
					Constant.output.write(SET);	Constant.output.write(CH2);	Constant.output.write(ch2.getSelectedIndex());
					Constant.output.write(SET);	Constant.output.write(CH3);	Constant.output.write(ch3.getSelectedIndex());
					Constant.output.write(SET);	Constant.output.write(TAG);	Constant.output.write(tag.getSelectedIndex());
					Constant.output.write(OVER);	Constant.output.write(OVER);	Constant.output.write(OVER);
					Constant.output.flush();
				}
				catch(IOException err)
				{
					if(s!=null)
					{
						try
						{
							s.close();
						}
						catch(IOException errr){}
					}
				} // do not show this message to avoid client attack.
			}
		}
		else
		{
			try
			{
				byte[] buffer=new byte[3];
				Vector setBuffer=new Vector();
				Constant.input.read(buffer);
				switch(buffer[0])
				{
					case SET:
						int[] temp=new int[2];
						temp[0]=buffer[1];
						temp[1]=buffer[2];
						setBuffer.addElement(temp);
						break;
					case OVER:
						if(setBuffer.size()==0) /* now you can agree on your selection */
						break;
					case AGREE:
						break;
					default:
				}
			}
			catch(IOException e)
			{
			}
		}
	}

// Handle window event
	public void windowActivated(WindowEvent e)
	{}
	public void windowClosed(WindowEvent e)
	{}
	public void windowClosing(WindowEvent e)
	{
		setVisible(false);
		Constant.resume();
	}
	public void windowDeactivated(WindowEvent e)
	{}
	public void windowDeiconified(WindowEvent e)
	{}
	public void windowIconified(WindowEvent e)
	{}
	public void windowOpened(WindowEvent e)
	{}
// End

	public void textValueChanged(TextEvent e)
	{
		Object source=e.getSource();
		if(source==serverName)
		{
			String tempString=serverName.getText();
			if(tempString==null || tempString.equals(""))
				connect.setEnabled(false);
			else
				connect.setEnabled(true);
		}
	}

	boolean connecting=false;
	public void actionPerformed(ActionEvent evt)
	{
		Object source=evt.getSource();
		if(source==connect)
		{
			connect.setLabel("Abort");
			cancel.setEnabled(false);
			connecting=true;
			Socket s=null;
			serverName.setEditable(false);
			serverName.setText("Connecting "+serverName.getText());
			try
			{
				s=new Socket(serverName.getText(), 9527);
				Constant.input=s.getInputStream();
				Constant.output=s.getOutputStream();
				byte[] tempBytes=new byte[5];
				Constant.input.read(tempBytes);
				for(int i=0;i<5;i++)
				{
					if(tempBytes[i]!=magicString[i])
						throw(new IOException());
				}
				Constant.output.write(magicString);
				connect.setLabel("Connect");
				connect.setEnabled(false);
				cancel.setEnabled(true);
				server.setEnabled(false);
				client.setEnabled(false);
				serverName.setText("Connected "+s.getInetAddress());
				
			}
			catch(UnknownHostException e)
			{
				new ErrorDialog("Unknow host");
				connecting=false;
				connect.setLabel("Connect");
				serverName.setEditable(true);
				cancel.setEnabled(true);
			}
			catch(IOException e)
			{
				new ErrorDialog("Cannot connect to the specified host");
				if(s!=null)
				{
					try
					{
						s.close();
					}
					catch(IOException err){}
				}
				connecting=false;
				connect.setLabel("Connect");
				serverName.setEditable(true);
				cancel.setEnabled(true);
			}
		}
	}

	public void itemStateChanged(ItemEvent e)
	{
		Object source=e.getSource();
		if(source==server)
		{
			if(mode)
				return;
			mode=true;
			connect.setEnabled(false);
			serverName.setEditable(false);
			lbl1.setEnabled(true);
			lbl2.setEnabled(true);
			lbl3.setEnabled(true);
			tag.setEnabled(true);
			ch1.setEnabled(true);
			ch2.setEnabled(true);
			ch3.setEnabled(true);
			return;
		}
		if(source==client)
		{
			if(!mode)
				return;
			mode=false;
			connect.setEnabled(false);
			serverName.setEditable(true);
			lbl1.setEnabled(false);
			lbl2.setEnabled(false);
			lbl3.setEnabled(false);
			tag.setEnabled(false);
			ch1.setEnabled(false);
			ch2.setEnabled(false);
			ch3.setEnabled(false);
			return;
		}
	}
}