/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.io.*;
import java.net.*;
import java.applet.*;

public class LanguageStrings
{
	public String languageName, resourceName;
	public boolean loaded=false;

	public String	menuGame, menuMore, menuHelp, menuNew, menuBest,
			menuExit, menuDisable,
			menuEnable, menuStyle, menuLanguage;
	public String menuHowTo, menuCopyright, menuLicense, menuAbout;
	public String howToPlayTitle, howToPlay;
	public String frameTitle, anonymousName, beginnerLevel, intermediateLevel,
			expertLevel, masterLevel, fastestSweeper, secondsString,
			resetScore, ok, cancel;
	public String copyright, aboutString, Chinamine, versionInfo,cprtInfo1,
			cprtInfo2, cprtDetail;
	public String congratulation, bestInfo1, bestInfo2, bestInfo3, bestInfo4,
			bestInfo5, bestInfo6;
	public String contributes, contributeList, menuTag;
	public String bestTimeDialogLevel, bestTimeDialogTime, bestTimeDialogName,
			bestTimeDialogTime2, bestTimeDialogName2;
	public String combat;

	public LanguageStrings(String name, String resourceName)
	{
		this.languageName=name;
		this.resourceName=resourceName;
	}

	public void loadLanguage()
	{
		if(loaded==true)
			return;
		BufferedReader br=null;
		if(!Constant.isApplet)
		{
			try
			{
				File iniFile=new File(resourceName);
				if(iniFile.exists() && iniFile.isFile() && iniFile.canRead())
				{
					br=new BufferedReader(new FileReader(iniFile));
				}
			}
			catch(IOException e)
			{
				return;
			}
		}
		else
		{
			Applet app=Constant.topApplet;
			try
			{
				URL langFileURL=new URL(app.getCodeBase(), resourceName);
				br=new BufferedReader(new InputStreamReader(langFileURL.openStream()));
			}
			catch(MalformedURLException e)
			{
				return;
			}
			catch(IOException e)
			{
				return;
			}
		}
		try
		{
// Here we introduce the usage of each string
			menuGame=getString(br); // The name of the Game menu.
			menuMore=getString(br); // The name of the More menu.
			menuHelp=getString(br); // The name of the Help menu
			menuNew=getString(br); // Game -> New
			menuBest=getString(br); // Game -> Best Score
			menuExit=getString(br); // Game -> Exit
			menuDisable=getString(br); // More -> Disable hot key
			menuEnable=getString(br); // More -> Enable hot key
			menuStyle=getString(br); // More -> select style
			menuLanguage=getString(br); // More -> select language
			menuHowTo=getString(br); // Help -> how to play
			menuCopyright=getString(br); // Help -> copyright
			menuLicense=getString(br); // Help -> License
			menuAbout=getString(br); // Help -> about China Mine
			howToPlayTitle=getString(br); // the title of How to play dialog
			howToPlay=getString(br); // the content of how to play dialog
			frameTitle=getString(br); // The first part of the string display in the title of game pad
			anonymousName=getString(br); // The name of anonymous player
			beginnerLevel=getString(br); // the level name of beginner
			intermediateLevel=getString(br); // the level name of intermediate
			expertLevel=getString(br); // the level name of expert level
			masterLevel=getString(br); // the level name of master level
			fastestSweeper=getString(br); // the title of show best time dialog
			secondsString=getString(br); // a second is 1/60 of a minute
			resetScore=getString(br); // the reset score string
			ok=getString(br); // the ok button
			cancel=getString(br); // the cancel button
			copyright=getString(br); // the copyright announcement
			aboutString=getString(br); // the title of the about dialog
			Chinamine=getString(br); // the name of the game
			versionInfo=getString(br); // the version information
			cprtInfo1=getString(br); // the 3 are copyright infomation, seperated in 3 lines.
			cprtInfo2=getString(br);
			cprtDetail=getString(br);
			congratulation=getString(br); // The title name of regist dialog
			bestInfo1=getString(br); // The 6 are best information, read the text content for meaning
			bestInfo2=getString(br); // & is used to replace level name
			bestInfo3=getString(br);
			bestInfo4=getString(br);
			bestInfo5=getString(br);
			bestInfo6=getString(br);
			contributes=getString(br); // The title of contribution dialog
			contributeList=getString(br); // the contribution list
			menuTag=getString(br); // Menu Game -> Dig with tag
			bestTimeDialogLevel=getString(br); // 'level' in best time dialog
			bestTimeDialogTime=getString(br); // 'time' in best time dialog
			bestTimeDialogName=getString(br); // 'name' in best time dialog
			bestTimeDialogTime2=getString(br); // 'time(no tag)' in best time dialog
			bestTimeDialogName2=getString(br); // 'name (no tag)' in best time dialog
			combat=getString(br);
			br.close();
		}
		catch(IOException e)
		{
			return;
		}
		catch(NullPointerException e)
		{
			return;
		}
		loaded=true;
	}

	public String getString(BufferedReader br) throws IOException
	{
		String tempString, returnString="";
		boolean inQote=false;
		while((tempString=br.readLine())!=null)
		{
			int first, second;
			if(tempString.startsWith("#"))
				continue;
			if((first=tempString.indexOf('\"'))==-1)
			{
				if(inQote)
					returnString=returnString.concat(tempString+"\n");
			}
			else
			{
				if(inQote)
				{
					try
					{
						returnString=returnString.concat(tempString.substring(0, first));
					}
					catch(StringIndexOutOfBoundsException e){}
					return returnString;
				}
				else if((second=tempString.indexOf('\"', first+1))==-1)
				{
					inQote=true;
					try
					{
						returnString=returnString.concat(tempString.substring(first+1)+"\n");
					}
					catch(StringIndexOutOfBoundsException e)
					{
						returnString=returnString.concat("\n");
					}
				}
				else
				{
					try
					{
						returnString=returnString.concat(tempString.substring(first+1, second));
					}
					catch(StringIndexOutOfBoundsException e){}
					return returnString;
				}
			}
		}
		return returnString;
	}
}
