/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;

class MainFrame extends Frame implements KeyListener, WindowListener, ActionListener, ItemListener
{
	public boolean enabled=true,helped=false;
	private static boolean alive=false;
	private MainCanvas canvas;

	private MainMenu mbar;

	public static boolean isAlive()
	{
		return alive;
	}

	public MainFrame()
	{
		super(Constant.languages[Config.language].frameTitle
				+Constant.levels[Config.level].levelNameFirstUpperCased);
		LevelConst lc=Constant.levels[Config.level];
//menu opt
		mbar=new MainMenu(this);
		setMenuBar(mbar);
//meun opt ends

		alive=true;
		setBounds(Config.xPos, Config.yPos, lc.panelW+10, lc.panelH+25);
		show();

		requestFocus();
		setLayout(new BorderLayout());
		canvas=new MainCanvas();
		Constant.onlyCanvas=canvas;
		add("Center", canvas);
		canvas.init();
		if(Constant.screenDim.height<600)
		{
			mbar.nameLevel[3].setEnabled(false);
		}
		canvas.start();
		setResizable(false);
		pack();
		addKeyListener(this);
		addWindowListener(this);
		canvas.addKeyListener(this);
	}

	private boolean firstNotify=true;
	public void addNotify()
	{
		super.addNotify();
		if(firstNotify)
		{
			StyleConst sc=Constant.styles[Config.style];
			Constant.onlyFrame=this;
			sc.processStyle();
			if(sc.loaded==false)
				ChinaMine.exit();// no any style avaliable, have to exit
			setIconImage(sc.icon);
			firstNotify=false;
		}
	}

// Handle window event
	public void windowActivated(WindowEvent e)
	{}
	public void windowClosed(WindowEvent e)
	{}
	public void windowClosing(WindowEvent e)
	{
		if(Config.hotKeyEnabled || F4Key==false)
			endFrame();
	}
	public void windowDeactivated(WindowEvent e)
	{}
	public void windowDeiconified(WindowEvent e)
	{}
	public void windowIconified(WindowEvent e)
	{}
	public void windowOpened(WindowEvent e)
	{}
// End

// Handle key event
	public boolean F4Key=false;
	public void keyPressed(KeyEvent key)
	{
		if(!enabled)
			return;

		if(Config.hotKeyEnabled)
		{
			switch(key.getKeyCode())
			{
				case KeyEvent.VK_F2:
					canvas.restart();
					break;
				case KeyEvent.VK_F1:
					if(helpWindow==null || helpWindow.exists==false)
						helpWindow=new ShowString(Constant.languages[Config.language].howToPlayTitle,
								Constant.languages[Config.language].howToPlay);
					else
					{
						helpWindow.toFront();
						helpWindow.requestFocus();
					}
					break;
			}
		}
	}

	public void keyReleased(KeyEvent key)
	{}
	public void keyTyped(KeyEvent key)
	{}
//End

	public static ShowString contributeWindow=null, helpWindow=null, copyrightWindow=null;

	public void itemStateChanged(ItemEvent evt)
	{
		Object target=evt.getSource();
		for(int i=0;i<mbar.nameLevel.length;i++)
		{
			if(target==mbar.nameLevel[i])
			{
				if(Config.level==i)
				{
					mbar.nameLevel[i].setState(true);
					canvas.restart();
					return;
				}
				for(int j=0;j<mbar.nameLevel.length;j++)
					mbar.nameLevel[j].setState(false);
				mbar.nameLevel[i].setState(true);
				int lastLevel=Config.level;
				Config.level=i;
				LevelConst lc=Constant.levels[i];
				setTitle(Constant.languages[Config.language].frameTitle+Constant.levels[Config.level].levelNameFirstUpperCased);
				canvas.init();
				if(Constant.isCombating)
				{
					Graphics g=canvas.getGraphics();
					g.clearRect(0, 0, Constant.screenDim.width, Constant.screenDim.height);
				}
				canvas.start();
				if(!Constant.isCombating)
					pack();
				return;
			}
		}

		if(target==mbar.combat)
		{
			Constant.isCombating=!Constant.isCombating;
			if(Constant.isCombating)
			{
				pack();
				setBounds(0,0,Constant.screenDim.width, Constant.screenDim.height);
				canvas.restart();
				enabled=false;
				setEnabled(false);
				new CombatDialog();
			}
			else
			{
				pack();
			}
		}

		for(int i=0;i<mbar.styles.length;i++)
		{
			if(target==mbar.styles[i])
			{
				for(int j=0;j<mbar.styles.length;j++)
					mbar.styles[j].setState(false);
				mbar.styles[i].setState(true);
				Config.style=i;
				Constant.styles[i].processStyle();
				canvas.sc=Constant.styles[i];
				canvas.styleChanged=true;
				canvas.repaint();
				setIconImage(canvas.sc.icon);
				Constant.topApplet.repaint();
				return;
			}
		}

		for(int i=0;i<mbar.languages.length;i++)
		{
			if(target==mbar.languages[i])
			{
				for(int j=0;j<mbar.languages.length;j++)
					mbar.languages[j].setState(false);
				mbar.languages[i].setState(true);
				Constant.languages[i].loadLanguage();
				Config.language=i;
				Constant.resetName();
				mbar.resetLabels();
				setTitle(Constant.languages[Config.language].frameTitle
						+Constant.levels[Config.level].levelNameFirstUpperCased);
				return;
			}
		}

		if(target==mbar.switchTag)
		{
			Config.canTag=!Config.canTag;
			mbar.switchTag.setState(Config.canTag);
			return;
		}
	}

	public void actionPerformed(ActionEvent evt)
	{
		Object target=evt.getSource();
		if(!enabled)
			return;
		if(target==mbar.newGame)
		{
			canvas.restart();
			return;
		}
		if(target==mbar.exitGame)
		{
			endFrame();
			return;
		}

		if(target==mbar.bestTime)
		{
			if(Constant.isApplet)
				Constant.topApplet.getAppletContext().showDocument(Constant.mineCGIurl, "_blank");
			else
				showBestTime();
			return;
		}

		if(target==mbar.aboutMine)
		{
			enabled=false;
			setEnabled(false);
			new AboutChinaMine();
			return;
		}

		if(target==mbar.contributes)
		{
			if(contributeWindow==null || contributeWindow.exists==false)
				contributeWindow=new ShowString(Constant.languages[Config.language].contributes,
						Constant.languages[Config.language].contributeList);
			else
			{
				contributeWindow.toFront();
				contributeWindow.requestFocus();
			}
			return;
		}

		if(target==mbar.copyright)
		{
			if(copyrightWindow==null || copyrightWindow.exists==false)
				copyrightWindow=new ShowString(Constant.languages[Config.language].menuCopyright,
						Constant.languages[Config.language].copyright);
			else
			{
				copyrightWindow.toFront();
				copyrightWindow.requestFocus();
			}
			return;
		}

		if(target==mbar.license)
		{
			try
			{
				Constant.topApplet.getAppletContext().showDocument(
						new URL(Constant.topApplet.getCodeBase(), "GPL.txt"), "_blank");
			}
			catch(MalformedURLException e){}
			return;
		}
		if(target==mbar.mineHelp)
		{
			if(helpWindow==null || helpWindow.exists==false)
				helpWindow=new ShowString(Constant.languages[Config.language].howToPlayTitle,
						Constant.languages[Config.language].howToPlay);
			else
			{
				helpWindow.toFront();
				helpWindow.requestFocus();
			}
			return;
		}

		if(target==mbar.switchHotKey)
		{
			Config.hotKeyEnabled=!Config.hotKeyEnabled;
			mbar.switchHotKey.setLabel(Config.hotKeyEnabled?Constant.languages[Config.language].menuDisable:
					Constant.languages[Config.language].menuEnable);
			return;
		}
	}

	private void showBestTime()
	{
		enabled=false;
		setEnabled(false);
		new ShowBestTime();
	}

	private void endFrame()
	{
		Config.xPos=getLocation().x;
		Config.yPos=getLocation().y;
		setVisible(false);
		dispose();
		alive=false;
		ChinaMine.exit();
	}
}
