/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

class Register extends Dialog implements Runnable, ActionListener, WindowListener, KeyListener
{
	private static Register[] lastRegisters={null,null,null,null,null,null,null,null};
	private static boolean dialogExists=false;
	private Thread thread;
	private TextField aNameField;
	private TextArea aCommentField;
	private Button anOK, aCancel;
	private int level,time;
	private boolean tag;
	private boolean nameReady=false, cancel=false;

	public Register(int time,int level, boolean tag)
	{
		super(Constant.onlyFrame, Constant.languages[Config.language].congratulation, false);
		this.level=level;
		this.time=time;
		this.tag=tag;
		//check if any previous thread exists
		if(tag)
		{
			if(time>=Constant.levels[level].winnerScore)
				return;
		}
		else
		{
			if(time>=Constant.levels[level].winnerScoreWithoutTag)
				return;
		}
		if(lastRegisters[level+(tag?(Constant.levels.length):0)]!=null)
		{
			if(time>=lastRegisters[level+(tag?(Constant.levels.length):0)].time)
				return;
			lastRegisters[level+(tag?(Constant.levels.length):0)].stop();
		}
		lastRegisters[level+(tag?(Constant.levels.length):0)]=this;
		thread=new Thread(this);
		thread.start();
	}

	public static void getBestTime(int level, boolean tag)
	{
		if(Constant.isApplet)
		{
			boolean exceptioned=true;
			try
			{
				URL getBestTimeURL=new URL(Constant.mineCGIstring+
					"+function_isbest+random_"+Constant.random.nextInt()%10000+
					"+level_"+level+"+tag_"+(tag?1:0));
//the cgi which get the best time
				BufferedReader br;

				br=new BufferedReader(new InputStreamReader(getBestTimeURL.openStream()));
				String returnString=br.readLine();
				if(returnString=="+err")
					throw(new IOException(br.readLine()));
				if(tag)
					Constant.levels[level].winnerScore=( new Integer(returnString) ).intValue();
				else
					Constant.levels[level].winnerScoreWithoutTag=( new Integer(returnString) ).intValue();
				br.close();
				exceptioned=false;
			}
			catch(NullPointerException e){}
			catch(MalformedURLException e){}
			catch(NumberFormatException e){}
			catch(IOException e){}
			finally
			{
				if(exceptioned)
				{
					System.out.println("Fail to get best time.");
					for(int i=0;i<Constant.levels.length;i++)
					{
						Constant.levels[i].winnerScore=0;
						Constant.levels[i].winnerScoreWithoutTag=0;
					}
				}
			}
		}
	}

	private static void setBestTime(int level,int bestTime,String name,String comment, boolean tag)
	{
		if(!Constant.isApplet)
		{
			if(tag)
			{
				Constant.levels[level].winnerScore=bestTime;
				Constant.levels[level].winnerName=name;
			}
			else
			{
				Constant.levels[level].winnerScoreWithoutTag=bestTime;
				Constant.levels[level].winnerNameWithoutTag=name;
			}
		}
		else
		{
			try
			{
				URL setBestTimeURL=new URL(Constant.mineCGIstring+
					"+function_register+random_"+Constant.random.nextInt()%10000);
//the cgi which set the best time
				URLConnection uc=setBestTimeURL.openConnection();
				uc.setDoOutput(true);
				urlSession(uc, level, bestTime, name, comment, tag);
			}
			catch(MalformedURLException e){e.printStackTrace();}
			catch(IOException e){e.printStackTrace();}
		}
	}

	private static void urlSession(URLConnection uc, int level, int time,
			String name, String comment, boolean tag) throws IOException
	{
		OutputStream output;
		InputStream input;
		byte[] buffer=new byte[710];
		byte[] string;
		output=uc.getOutputStream();
		output.write("\"IAMJMa v 1.1.x\"".getBytes());
		buffer[0]=(byte)(level+(tag?4:0));
		buffer[1]=(byte)time;
		buffer[2]=(byte)(time/256);
		if(name.length()>32)
			name=name.substring(0, 32);
		else if(name.length()==0)
			name="   "; /* leave three space because some netscape cant show blank table item correctly */
		int commentLength=0;
		for(int i=0;i<5;i++)
		{
			commentLength=comment.indexOf('\n', commentLength)+1;
			if(commentLength>499||commentLength<=0)
				break;
		}
		if(commentLength<=0)
			commentLength=comment.length();
		if(commentLength>499)
			commentLength=499;
		if(commentLength>0)
			comment=comment.substring(0, commentLength);
		else
			comment="   "; /* leave three space because some netscape cant show blank table item correctly */
		string=name.getBytes();
		int tempInt=((199>string.length)?string.length:199);
		for(int i=0;i<tempInt;i++)
			buffer[10+i]=string[i];
		buffer[10+tempInt]=0;
		string=comment.getBytes();
		tempInt=((499>string.length)?string.length:499);
		for(int i=0;i<tempInt;i++)
			buffer[210+i]=string[i];
		buffer[210+tempInt]=0;
		output.write(buffer);
		output.flush();
		output.close();
		input=uc.getInputStream();
		input.read();
		input.close();
	}

	public void stop()
	{
		if(isVisible())
		{
			closeWindow();
		}
		if(thread!=null)
			thread.stop();
	}

	public void run()
	{
		getBestTime(level, tag);
		int bestTime=tag?(Constant.levels[level].winnerScore):
				(Constant.levels[level].winnerScoreWithoutTag);
		if(time>=bestTime)
		{
			lastRegisters[level+(tag?(Constant.levels.length):0)]=null;
		}
		else
		{
			while(true)
			{
				if(!dialogExists)
					break;
				try
				{
					Thread.sleep(100);
				}
				catch(InterruptedException e){}
			}
			dialogExists=true;
			Constant.onlyFrame.setEnabled(false);
			Constant.onlyFrame.enabled=false;
			showNameDialog();
			while(true)
			{
				if(nameReady || cancel)
					break;
				try
				{
					Thread.sleep(100);
				}
				catch(InterruptedException e){}
			}
			closeWindow();
			if(!cancel)
			{
				if(!Constant.isApplet)
					setBestTime(level,time,aNameField.getText(), null, tag);
				else
					setBestTime(level,time,aNameField.getText(), aCommentField.getText(), tag);
				if(!Constant.isApplet)
				{
					Constant.onlyFrame.setEnabled(false);
					Constant.onlyFrame.enabled=false;
					new ShowBestTime();
				}
			}
			lastRegisters[level+(tag?(Constant.levels.length):0)]=null;
		}
	}

	private void showNameDialog()
	{
		Font font=getFont();
		setLocation(100,100);
		GridBagConstraints gbc=new GridBagConstraints();
		GridBagLayout layout=new GridBagLayout();
		Insets zeroInsets=new Insets(0,20,0,20);
		setLayout(layout);
		String bi1=Constant.languages[Config.language].bestInfo1;
		String bi2=Constant.languages[Config.language].bestInfo2;
		String notag=Constant.languages[Config.language].bestInfo6;
		int index;
		if((index=bi1.indexOf('&'))>=0)
			bi1=bi1.substring(0, index)+Constant.levels[level].levelNameLowerCased+bi1.substring(index+1);
		if((index=bi2.indexOf('&'))>=0)
			bi2=bi2.substring(0, index)+Constant.levels[level].levelNameLowerCased+bi2.substring(index+1);
		Label label1=new Label(bi1,Label.CENTER);		
		Label label2=new Label(bi2,Label.CENTER);
		Label label3=new Label(Constant.languages[Config.language].bestInfo3, Label.CENTER);
		Label label4=null, label5=null, label6=null;
		aNameField=new TextField(Constant.levels[level].winnerName,20);
		anOK=new Button(Constant.languages[Config.language].ok);
		aCancel=new Button(Constant.languages[Config.language].cancel);
		int row=0;
		gbc.gridwidth=2;
		gbc.gridx=0;
		gbc.gridy=row++;
		gbc.insets=new Insets(10,20,0,20);
		layout.setConstraints(label1,gbc);
		gbc.gridy=row++;
		gbc.insets=zeroInsets;
		layout.setConstraints(label2,gbc);
		if(!tag)
		{
			gbc.gridy=row++;
			gbc.insets=zeroInsets;
			label6=new Label(notag, Label.CENTER);
			layout.setConstraints(label6,gbc);
		}
		gbc.gridy=row++;
		gbc.insets=zeroInsets;
		layout.setConstraints(label3,gbc);
		gbc.gridy=row++;
		gbc.insets=new Insets(30,20,7,20);
		layout.setConstraints(aNameField,gbc);
		if(Constant.isApplet)
		{
			label4=new Label(Constant.languages[Config.language].bestInfo4,  Label.CENTER);
			gbc.insets=new Insets(20,20,0,20);
			gbc.gridy=row++;
			layout.setConstraints(label4, gbc);
			label5=new Label(Constant.languages[Config.language].bestInfo5,  Label.CENTER);
			gbc.gridy=row++;
			gbc.insets=zeroInsets;
			layout.setConstraints(label5, gbc);
			aCommentField=new TextArea("", 5, 20, TextArea.SCROLLBARS_NONE);
			gbc.insets=new Insets(0,20,20,20);
			gbc.gridy=row++;
			layout.setConstraints(aCommentField, gbc);
		}
		gbc.gridy=row++;
		gbc.gridwidth=1;
		gbc.weightx=50;
		gbc.insets=new Insets(5,20,20,5);
		gbc.ipadx=20;
		gbc.anchor=GridBagConstraints.EAST;
		gbc.gridx=0;
		layout.setConstraints(anOK,gbc);
		gbc.gridx=1;
		gbc.insets=new Insets(5,5,20,20);
		gbc.anchor=GridBagConstraints.WEST;
		layout.setConstraints(aCancel,gbc);
		add(label1);
		add(label2);
		if(!tag)
			add(label6);
		add(label3);
		add(aNameField);
		if(Constant.isApplet)
		{
			add(label4);
			add(label5);
			add(aCommentField);
		}
		add(anOK);
		add(aCancel);
		pack();
		setResizable(false);
		aNameField.selectAll();
		aNameField.requestFocus();
		aNameField.addActionListener(this);
		aNameField.addKeyListener(this);
		if(Constant.isApplet)
			aCommentField.addKeyListener(this);
		anOK.addKeyListener(this);
		aCancel.addKeyListener(this);
		anOK.addActionListener(this);
		aCancel.addActionListener(this);
		addWindowListener(this);
		addKeyListener(this);
		show();
	}

	public void actionPerformed(ActionEvent evt)
	{
		if(evt.getSource() instanceof Button)
		{
			if(evt.getSource()==anOK)
				nameReady=true;
			else
				cancel=true;
		}
		else if(evt.getSource() instanceof TextField && Config.hotKeyEnabled)
			nameReady=true;
	}

// Handle key event
	public void keyPressed(KeyEvent key)
	{
		if(Config.hotKeyEnabled && key.getKeyCode()==KeyEvent.VK_ESCAPE)//ESC
			cancel=true;
	}
	public void keyReleased(KeyEvent key)
	{}
	public void keyTyped(KeyEvent key)
	{}
//End

// Handle window event
	public void windowActivated(WindowEvent e)
	{}
	public void windowClosed(WindowEvent e)
	{}
	public void windowClosing(WindowEvent e)
	{
		cancel=true;
	}
	public void windowDeactivated(WindowEvent e)
	{}
	public void windowDeiconified(WindowEvent e)
	{}
	public void windowIconified(WindowEvent e)
	{}
	public void windowOpened(WindowEvent e)
	{}
// End

	public void closeWindow()
	{
		setVisible(false);
		Constant.resume();
		dialogExists=false;
	}
}
