/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

#define FLOCK
#include "misc.h"

#ifdef FLOCK
#include <sys/stat.h>
#include <sys/file.h>
static int fd;
#endif

#ifdef FSOPEN
#include <stdio.h>
#include <share.h>
#include <stdlib.h>
static FILE *fp;
#endif

#define LOCKFILE "mineCGI.lockfile"
static int locked=0;

void get_lock()
{
	if(!locked)
	{
#ifdef NO_LOCK_METHOD
#endif
#ifdef FLOCK
		makeFilename(LOCKFILE);
		fd=open(buffer, O_RDONLY|O_CREAT, S_IREAD);
		flock(fd, LOCK_EX);
#endif
#ifdef FSOPEN
		makeFilename(LOCKFILE);
		fp=_fsopen(buffer, "wb", _SH_DENYRW);
		while(fp==NULL)
		{
			_sleep(200);
			fp=_fsopen(buffer, "wb", _SH_DENYRW);
		}
#endif
		locked=1;
	}
}

void release_lock()
{
	if(locked)
	{
#ifdef NO_LOCK_METHOD
#endif
#ifdef FLOCK
		flock(fd, LOCK_UN);
		close(fd);
#endif
#ifdef FSOPEN
		fclose(fp);
#endif
		locked=0;
	}
}
